%
%
%
\sectionB{Progress lemmas}

The following lemmas are technical lemmas used in the proof of {\sc Progress}.  Most often, they
establish the kinds of values that can be associated with each type.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Variables
%
\begin{lemma}
\thmtitle\vardeclarationlemma{lemma:var-declaration}{Variable declarations}
If $\withgenv{v : t}$, then $v \in \dom{\genv}$.
\end{lemma}

\begin{proof}
The only rule that can be used to derive a type for a variable is the \refmath{Ty-AtomVar} rule.

$$\tyatomvar$$
\end{proof}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SCALARS
%
The following lemma is used in the proof of {\sc Progress}.

\begin{lemma}
\thmtitle\numericvalueslemma{lemma:numeric-values}{Numeric Values}
For any derivation $\withgenv{h : t}$ where the type $t$ is a numeric type,
including $\tyint$, $\tyenum{n}$, $\tyrawint{\pre}{\sign}$, and $\tyfloat{\fpre}$, the value $h$
is either a constant or a variable.
\end{lemma}

\begin{proof}
The cases are similar, we illustrate with the case for integers $\tyint$.
There are two rules that can derive $\withgenv{h : \tyint}$.

\begin{itemize}
\item
The first is the \refmath{Ty-AtomInt} rule, where the atom $h$
must be an integer $i$.

$$\tyatomint$$

\item
\settypename{\tyint}
In the second case, the value is derived using the \refmath{Ty-AtomVar} rule.

$$\tyatomvar$$

In this case, the value is a variable $v$.
\end{itemize}
\end{proof}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FUNCTIONS
%
\begin{lemma}
\thmtitle\functionvalueslemma{lemma:function-values}{Function Values}
For any derivation $\withgenv{h : \tyfun{\argvec{u\subi}{\varbase}{\varbound}}{t}}$, the value $h$
must be a variable $v$.  If $v$ is defined in the context $\genv$, the value has the form
$\storefun{\cvec{v\subi}{\varbase}{\varbound}}{e}$.
\end{lemma}

\begin{proof}
The premise $h : \tyfun{\argvec{u\subi}{\varbase}{\varbound}}{t}$ can be proved only with the
\refmath{Ty-AtomVar} rule.

\begin{block}
\settypename{\tyfun{\argvec{u\subi}{\varbase}{\varbound}}{t}}
$$\tyatomvar$$
\end{block}

That is, $h$ must be a variable $v$.  The only possible typing rule is the
\refmath{Ty-StoreFun-Mono} rule.

$$\tystorefunmono$$
\end{proof}

% -*-
% Local Variables:
% Mode: LaTeX
% fill-column: 100
% TeX-master: "paper"
% TeX-command-default: "LaTeX/dvips Interactive"
% End:
% -*-
